import React from "react";
import { useSelector } from "react-redux";
import {
  School,
  SchoolCard,
  Title,
  Card,
  Hogwarts,
} from "../../styles/houses-style.js";

const Houses = () => {
  const housePoints = useSelector((state) => [
    state.housePoints.House1,
    state.housePoints.House2,
    state.housePoints.House3,
    state.housePoints.House4,
  ]);

  const cards = housePoints.sort(function (a, b) {
    return b.score - a.score;
  });

  return (
    <School>
      <Title>
        <svg
          width="100"
          height="150"
          viewBox="0 0 120 128"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            d="M10.2125 52.9003C11.189 53.0819 12.2225 53.1796 13.2529 53.1796C14.7747 53.1796 16.2812 52.9506 17.6079 52.4751C14.9182 59.7559 9.82512 66.4765 0.866633 71.1016C0.484753 71.2986 0.201977 71.6579 0.0853797 72.0895C-0.0297696 72.5211 0.0343646 72.9843 0.2632 73.3629L11.9368 92.7513C12.2662 93.2991 12.8783 93.5807 13.4891 93.4507L19.4009 92.202C20.22 96.8284 23.536 109.163 35.6527 110.244C50.8316 111.598 57.1079 123.403 58.1981 125.718C58.2404 125.928 58.322 126.132 58.4372 126.315C58.7126 126.762 59.2272 127.03 59.7315 127.03C60.2358 127.03 60.7051 126.762 60.9806 126.315C61.1103 126.108 61.1876 125.874 61.2138 125.634C62.4105 123.132 68.7159 111.582 83.7199 110.244C95.8351 109.163 99.1525 96.8284 99.9731 92.202L105.885 93.4507C106.494 93.5792 107.108 93.2991 107.437 92.7513L119.109 73.3629C119.338 72.9843 119.402 72.5211 119.287 72.0895C119.171 71.6579 118.888 71.2986 118.506 71.1016C110.269 66.8487 104.634 60.5947 101.631 52.428C102.989 52.9376 104.547 53.1796 106.12 53.1796C107.15 53.1796 108.184 53.0819 109.16 52.9003C113.737 52.0517 118.812 49.1687 119.335 43.622C119.386 43.085 119.172 42.5571 118.77 42.2247L109.794 34.813C111.607 31.7123 112.445 28.5038 112.292 25.2161C111.861 15.9524 103.683 9.66013 103.336 9.39698C103.318 9.38371 103.297 9.38247 103.279 9.37005C103.259 9.35622 103.247 9.33457 103.226 9.32158L90.2221 1.18966C89.6478 0.830345 88.9132 0.918824 88.4278 1.4074C88.3185 1.51897 77.2542 12.5077 59.6411 12.5077C42.1752 12.5077 31.0526 1.51744 30.9433 1.40587C30.4594 0.918824 29.7262 0.829573 29.1505 1.18966L16.1462 9.32158C16.1252 9.33466 16.1133 9.35641 16.0932 9.37035C16.0754 9.38256 16.0544 9.3839 16.0369 9.39698C15.69 9.66013 7.51163 15.9524 7.08018 25.2161C6.92714 28.5038 7.76524 31.7123 9.57844 34.813L0.602812 42.2247C0.200529 42.5571 -0.0137399 43.085 0.037275 43.622C0.560544 49.1687 5.63575 52.0517 10.2125 52.9003ZM35.9034 107.103C23.5622 106.002 22.1819 90.8439 22.128 90.1999C22.0916 89.7529 21.8773 89.3428 21.5377 89.0735C21.2768 88.8673 20.9605 88.7573 20.6398 88.7573C20.5422 88.7573 20.4445 88.7673 20.3483 88.7881L13.9074 90.1484L3.66077 73.1321C8.96992 70.1332 12.921 66.4272 15.84 62.3341H58.1938V119.862C54.6881 114.992 47.746 108.16 35.9034 107.103ZM115.712 73.1321L105.467 90.1484L99.0257 88.7881C98.6059 88.6988 98.1745 88.8035 97.8349 89.0735C97.4953 89.3436 97.281 89.7537 97.2461 90.2015C97.2329 90.3592 95.8497 105.999 83.4692 107.103C71.6266 108.16 64.6845 114.992 61.1788 119.862V62.3341H103.532C106.452 66.4272 110.403 70.1332 115.712 73.1321ZM116.228 44.1275C115.433 47.399 111.881 49.1964 108.644 49.7965C105.031 50.4652 101.474 49.6588 100.719 47.9961C100.061 46.5458 101.505 43.9782 104.583 41.126C105.91 39.898 107.066 38.6477 108.052 37.3759L116.228 44.1275ZM109.312 25.3877C109.446 28.3699 108.53 31.3237 106.585 34.2136C106.573 34.2306 106.561 34.2475 106.55 34.2644C105.522 35.7809 104.209 37.2805 102.616 38.7578C101.193 40.0754 100.144 41.2842 99.3772 42.3913C99.1369 40.1097 99.0281 37.7347 99.0884 35.2408C99.3205 25.6229 101.838 17.0603 103.11 13.3093C105.284 15.4269 109.062 19.8667 109.312 25.3877ZM89.6361 4.48583L100.616 11.3521C98.5815 17.1311 91.2635 41.0076 101.53 59.1826H61.1788V15.6122C76.4362 15.1217 86.6903 7.10663 89.6361 4.48583ZM29.7364 4.48583C32.6783 7.10115 42.9117 15.0925 58.1938 15.6095V59.1826H17.8426C28.1091 41.0076 20.791 17.1311 18.7567 11.3521L29.7364 4.48583ZM10.0609 25.3877C10.3104 19.8694 14.0845 15.4311 16.2597 13.3122C17.8196 17.9481 21.2423 29.9215 19.9235 42.2825C19.1634 41.2056 18.1322 40.0315 16.7569 38.7578C15.1638 37.2805 13.8505 35.7809 12.823 34.2644C12.8113 34.2475 12.7996 34.2306 12.788 34.2136C10.8421 31.3237 9.9268 28.3699 10.0609 25.3877ZM11.3202 37.3759C12.307 38.6477 13.4628 39.898 14.7892 41.126C17.8676 43.9782 19.312 46.5458 18.6532 47.9961C17.8967 49.6596 14.3417 50.4659 10.7285 49.7965C7.49121 49.1964 3.93916 47.399 3.14478 44.1275L11.3202 37.3759Z"
            fill="white"
          />
        </svg>

        <Hogwarts>Hogwarts Score Manager</Hogwarts>
      </Title>
      <SchoolCard>
        {cards.map(({ score, house, logo }, index) =>
          house === undefined ? (
            <Card key={index}>
              <h2>{`#${index + 1}`}</h2>
              <svg
                width="298"
                height="361"
                viewBox="0 0 298 361"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path d={logo} fill="#5777A8" />
              </svg>
              <h2>{score}</h2>
            </Card>
          ) : (
            <Card key={index}>
              <h2>{`#${index + 1} ${house}`}</h2>
              <svg
                width="298"
                height="361"
                viewBox="0 0 298 361"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path d={logo} fill="#5777A8" />
              </svg>
              <h2>{score}</h2>
            </Card>
          )
        )}
      </SchoolCard>
    </School>
  );
};

export default Houses;
